/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Keys;
import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumDocument;
import de.jottyfan.camporganizer.db.jooq.enums.EnumFiletype;
import de.jottyfan.camporganizer.db.jooq.tables.TCamp.TCampPath;
import de.jottyfan.camporganizer.db.jooq.tables.TCampdocument.TCampdocumentPath;
import de.jottyfan.camporganizer.db.jooq.tables.TDocumentrole.TDocumentrolePath;
import de.jottyfan.camporganizer.db.jooq.tables.TLocation.TLocationPath;
import de.jottyfan.camporganizer.db.jooq.tables.records.TDocumentRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class TDocument extends TableImpl<TDocumentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.t_document</code>
     */
    public static final TDocument T_DOCUMENT = new TDocument();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDocumentRecord> getRecordType() {
        return TDocumentRecord.class;
    }

    /**
     * The column <code>public.t_document.pk</code>.
     */
    public final TableField<TDocumentRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>public.t_document.doctype</code>.
     */
    public final TableField<TDocumentRecord, EnumDocument> DOCTYPE = createField(DSL.name("doctype"), SQLDataType.VARCHAR.asEnumDataType(EnumDocument.class), this, "");

    /**
     * The column <code>public.t_document.name</code>.
     */
    public final TableField<TDocumentRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_document.document</code>.
     */
    public final TableField<TDocumentRecord, String> DOCUMENT = createField(DSL.name("document"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_document.filetype</code>.
     */
    public final TableField<TDocumentRecord, EnumFiletype> FILETYPE = createField(DSL.name("filetype"), SQLDataType.VARCHAR.asEnumDataType(EnumFiletype.class), this, "");

    private TDocument(Name alias, Table<TDocumentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDocument(Name alias, Table<TDocumentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>public.t_document</code> table reference
     */
    public TDocument(String alias) {
        this(DSL.name(alias), T_DOCUMENT);
    }

    /**
     * Create an aliased <code>public.t_document</code> table reference
     */
    public TDocument(Name alias) {
        this(alias, T_DOCUMENT);
    }

    /**
     * Create a <code>public.t_document</code> table reference
     */
    public TDocument() {
        this(DSL.name("t_document"), null);
    }

    public <O extends Record> TDocument(Table<O> path, ForeignKey<O, TDocumentRecord> childPath, InverseForeignKey<O, TDocumentRecord> parentPath) {
        super(path, childPath, parentPath, T_DOCUMENT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDocumentPath extends TDocument implements Path<TDocumentRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDocumentPath(Table<O> path, ForeignKey<O, TDocumentRecord> childPath, InverseForeignKey<O, TDocumentRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDocumentPath(Name alias, Table<TDocumentRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDocumentPath as(String alias) {
            return new TDocumentPath(DSL.name(alias), this);
        }

        @Override
        public TDocumentPath as(Name alias) {
            return new TDocumentPath(alias, this);
        }

        @Override
        public TDocumentPath as(Table<?> alias) {
            return new TDocumentPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public Identity<TDocumentRecord, Integer> getIdentity() {
        return (Identity<TDocumentRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDocumentRecord> getPrimaryKey() {
        return Keys.T_DOCUMENT_PKEY;
    }

    @Override
    public List<UniqueKey<TDocumentRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_DOCUMENT_NAME_KEY);
    }

    private transient TCampPath _tCamp;

    /**
     * Get the implicit to-many join path to the <code>public.t_camp</code>
     * table
     */
    public TCampPath tCamp() {
        if (_tCamp == null)
            _tCamp = new TCampPath(this, null, Keys.T_CAMP__T_CAMP_FK_DOCUMENT_FKEY.getInverseKey());

        return _tCamp;
    }

    private transient TCampdocumentPath _tCampdocument;

    /**
     * Get the implicit to-many join path to the
     * <code>public.t_campdocument</code> table
     */
    public TCampdocumentPath tCampdocument() {
        if (_tCampdocument == null)
            _tCampdocument = new TCampdocumentPath(this, null, Keys.T_CAMPDOCUMENT__T_CAMPDOCUMENT_FK_DOCUMENT_FKEY.getInverseKey());

        return _tCampdocument;
    }

    private transient TDocumentrolePath _tDocumentrole;

    /**
     * Get the implicit to-many join path to the
     * <code>public.t_documentrole</code> table
     */
    public TDocumentrolePath tDocumentrole() {
        if (_tDocumentrole == null)
            _tDocumentrole = new TDocumentrolePath(this, null, Keys.T_DOCUMENTROLE__T_DOCUMENTROLE_FK_DOCUMENT_FKEY.getInverseKey());

        return _tDocumentrole;
    }

    private transient TLocationPath _tLocation;

    /**
     * Get the implicit to-many join path to the <code>public.t_location</code>
     * table
     */
    public TLocationPath tLocation() {
        if (_tLocation == null)
            _tLocation = new TLocationPath(this, null, Keys.T_LOCATION__T_LOCATION_FK_DOCUMENT_FKEY.getInverseKey());

        return _tLocation;
    }

    @Override
    public TDocument as(String alias) {
        return new TDocument(DSL.name(alias), this);
    }

    @Override
    public TDocument as(Name alias) {
        return new TDocument(alias, this);
    }

    @Override
    public TDocument as(Table<?> alias) {
        return new TDocument(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDocument rename(String name) {
        return new TDocument(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDocument rename(Name name) {
        return new TDocument(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDocument rename(Table<?> name) {
        return new TDocument(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument where(Condition condition) {
        return new TDocument(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDocument where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDocument where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDocument where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDocument where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDocument whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
