/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumCamprole;
import de.jottyfan.camporganizer.db.jooq.tables.records.VAdultRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;
import org.jooq.types.YearToSecond;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VAdult extends TableImpl<VAdultRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_adult</code>
     */
    public static final VAdult V_ADULT = new VAdult();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VAdultRecord> getRecordType() {
        return VAdultRecord.class;
    }

    /**
     * The column <code>public.v_adult.age</code>.
     */
    public final TableField<VAdultRecord, YearToSecond> AGE = createField(DSL.name("age"), SQLDataType.INTERVAL, this, "");

    /**
     * The column <code>public.v_adult.forename</code>.
     */
    public final TableField<VAdultRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_adult.surname</code>.
     */
    public final TableField<VAdultRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_adult.camprole</code>.
     */
    public final TableField<VAdultRecord, EnumCamprole> CAMPROLE = createField(DSL.name("camprole"), SQLDataType.VARCHAR.asEnumDataType(EnumCamprole.class), this, "");

    /**
     * The column <code>public.v_adult.adult</code>.
     */
    public final TableField<VAdultRecord, Boolean> ADULT = createField(DSL.name("adult"), SQLDataType.BOOLEAN, this, "");

    private VAdult(Name alias, Table<VAdultRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VAdult(Name alias, Table<VAdultRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_adult" AS  SELECT age((t_person.birthdate)::timestamp with time zone) AS age,
         t_person.forename,
         t_person.surname,
         t_person.camprole,
         (age((t_person.birthdate)::timestamp with time zone) > '18 years'::interval) AS adult
        FROM t_person;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_adult</code> table reference
     */
    public VAdult(String alias) {
        this(DSL.name(alias), V_ADULT);
    }

    /**
     * Create an aliased <code>public.v_adult</code> table reference
     */
    public VAdult(Name alias) {
        this(alias, V_ADULT);
    }

    /**
     * Create a <code>public.v_adult</code> table reference
     */
    public VAdult() {
        this(DSL.name("v_adult"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VAdult as(String alias) {
        return new VAdult(DSL.name(alias), this);
    }

    @Override
    public VAdult as(Name alias) {
        return new VAdult(alias, this);
    }

    @Override
    public VAdult as(Table<?> alias) {
        return new VAdult(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VAdult rename(String name) {
        return new VAdult(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VAdult rename(Name name) {
        return new VAdult(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VAdult rename(Table<?> name) {
        return new VAdult(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult where(Condition condition) {
        return new VAdult(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VAdult where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VAdult where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VAdult where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VAdult where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VAdult whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
