/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.tables.records.VBudgetRecord;

import java.math.BigDecimal;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VBudget extends TableImpl<VBudgetRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_budget</code>
     */
    public static final VBudget V_BUDGET = new VBudget();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VBudgetRecord> getRecordType() {
        return VBudgetRecord.class;
    }

    /**
     * The column <code>public.v_budget.budget</code>.
     */
    public final TableField<VBudgetRecord, BigDecimal> BUDGET = createField(DSL.name("budget"), SQLDataType.NUMERIC, this, "");

    /**
     * The column <code>public.v_budget.fk_camp</code>.
     */
    public final TableField<VBudgetRecord, Integer> FK_CAMP = createField(DSL.name("fk_camp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_budget.name</code>.
     */
    public final TableField<VBudgetRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_budget.location</code>.
     */
    public final TableField<VBudgetRecord, String> LOCATION = createField(DSL.name("location"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_budget.year</code>.
     */
    public final TableField<VBudgetRecord, Double> YEAR = createField(DSL.name("year"), SQLDataType.DOUBLE, this, "");

    private VBudget(Name alias, Table<VBudgetRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VBudget(Name alias, Table<VBudgetRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_budget" AS  SELECT sum(v_sales.cash) AS budget,
          v_sales.fk_camp,
          v_sales.name,
          v_sales.location,
          v_sales.year
         FROM v_sales
        GROUP BY v_sales.fk_camp, v_sales.name, v_sales.location, v_sales.year;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_budget</code> table reference
     */
    public VBudget(String alias) {
        this(DSL.name(alias), V_BUDGET);
    }

    /**
     * Create an aliased <code>public.v_budget</code> table reference
     */
    public VBudget(Name alias) {
        this(alias, V_BUDGET);
    }

    /**
     * Create a <code>public.v_budget</code> table reference
     */
    public VBudget() {
        this(DSL.name("v_budget"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VBudget as(String alias) {
        return new VBudget(DSL.name(alias), this);
    }

    @Override
    public VBudget as(Name alias) {
        return new VBudget(alias, this);
    }

    @Override
    public VBudget as(Table<?> alias) {
        return new VBudget(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VBudget rename(String name) {
        return new VBudget(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VBudget rename(Name name) {
        return new VBudget(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VBudget rename(Table<?> name) {
        return new VBudget(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget where(Condition condition) {
        return new VBudget(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VBudget where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VBudget where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VBudget where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VBudget where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VBudget whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
