/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.tables.records.VCampBudgetRecord;

import java.math.BigDecimal;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VCampBudget extends TableImpl<VCampBudgetRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_camp_budget</code>
     */
    public static final VCampBudget V_CAMP_BUDGET = new VCampBudget();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCampBudgetRecord> getRecordType() {
        return VCampBudgetRecord.class;
    }

    /**
     * The column <code>public.v_camp_budget.budget</code>.
     */
    public final TableField<VCampBudgetRecord, BigDecimal> BUDGET = createField(DSL.name("budget"), SQLDataType.NUMERIC, this, "");

    /**
     * The column <code>public.v_camp_budget.fk_camp</code>.
     */
    public final TableField<VCampBudgetRecord, Integer> FK_CAMP = createField(DSL.name("fk_camp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_camp_budget.camp_name</code>.
     */
    public final TableField<VCampBudgetRecord, String> CAMP_NAME = createField(DSL.name("camp_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_camp_budget.year</code>.
     */
    public final TableField<VCampBudgetRecord, Double> YEAR = createField(DSL.name("year"), SQLDataType.DOUBLE, this, "");

    private VCampBudget(Name alias, Table<VCampBudgetRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCampBudget(Name alias, Table<VCampBudgetRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_camp_budget" AS  WITH x(money, camp) AS (
                SELECT COALESCE(t_person.paid, 0.0) AS cash,
                   t_person.fk_camp
                  FROM t_person
               UNION ALL
                SELECT (t_sales.cash * ('-1'::integer)::numeric),
                   t_sales.fk_camp
                  FROM t_sales
               )
        SELECT sum(x.money) AS budget,
           c.pk AS fk_camp,
           c.name AS camp_name,
           date_part('year'::text, c.arrive) AS year
          FROM (x
            LEFT JOIN t_camp c ON ((c.pk = x.camp)))
         GROUP BY c.pk, c.name, c.arrive
         ORDER BY c.arrive;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_camp_budget</code> table reference
     */
    public VCampBudget(String alias) {
        this(DSL.name(alias), V_CAMP_BUDGET);
    }

    /**
     * Create an aliased <code>public.v_camp_budget</code> table reference
     */
    public VCampBudget(Name alias) {
        this(alias, V_CAMP_BUDGET);
    }

    /**
     * Create a <code>public.v_camp_budget</code> table reference
     */
    public VCampBudget() {
        this(DSL.name("v_camp_budget"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VCampBudget as(String alias) {
        return new VCampBudget(DSL.name(alias), this);
    }

    @Override
    public VCampBudget as(Name alias) {
        return new VCampBudget(alias, this);
    }

    @Override
    public VCampBudget as(Table<?> alias) {
        return new VCampBudget(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCampBudget rename(String name) {
        return new VCampBudget(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCampBudget rename(Name name) {
        return new VCampBudget(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCampBudget rename(Table<?> name) {
        return new VCampBudget(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget where(Condition condition) {
        return new VCampBudget(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCampBudget where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCampBudget where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCampBudget where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCampBudget where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCampBudget whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
