/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.tables.records.VSalesRecord;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VSales extends TableImpl<VSalesRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_sales</code>
     */
    public static final VSales V_SALES = new VSales();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VSalesRecord> getRecordType() {
        return VSalesRecord.class;
    }

    /**
     * The column <code>public.v_sales.pk</code>.
     */
    public final TableField<VSalesRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_sales.trader</code>.
     */
    public final TableField<VSalesRecord, String> TRADER = createField(DSL.name("trader"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.fk_camp</code>.
     */
    public final TableField<VSalesRecord, Integer> FK_CAMP = createField(DSL.name("fk_camp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_sales.name</code>.
     */
    public final TableField<VSalesRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.fk_location</code>.
     */
    public final TableField<VSalesRecord, Integer> FK_LOCATION = createField(DSL.name("fk_location"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_sales.location</code>.
     */
    public final TableField<VSalesRecord, String> LOCATION = createField(DSL.name("location"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.incredients</code>.
     */
    public final TableField<VSalesRecord, String> INCREDIENTS = createField(DSL.name("incredients"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.year</code>.
     */
    public final TableField<VSalesRecord, Double> YEAR = createField(DSL.name("year"), SQLDataType.DOUBLE, this, "");

    /**
     * The column <code>public.v_sales.fk_sales</code>.
     */
    public final TableField<VSalesRecord, Integer> FK_SALES = createField(DSL.name("fk_sales"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_sales.provider</code>.
     */
    public final TableField<VSalesRecord, String> PROVIDER = createField(DSL.name("provider"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.cash</code>.
     */
    public final TableField<VSalesRecord, BigDecimal> CASH = createField(DSL.name("cash"), SQLDataType.NUMERIC(11, 2), this, "");

    /**
     * The column <code>public.v_sales.buydate</code>.
     */
    public final TableField<VSalesRecord, LocalDateTime> BUYDATE = createField(DSL.name("buydate"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>public.v_sales.recipenumber</code>.
     */
    public final TableField<VSalesRecord, String> RECIPENUMBER = createField(DSL.name("recipenumber"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.recipeshot</code>.
     */
    public final TableField<VSalesRecord, byte[]> RECIPESHOT = createField(DSL.name("recipeshot"), SQLDataType.BLOB, this, "");

    /**
     * The column <code>public.v_sales.recipenote</code>.
     */
    public final TableField<VSalesRecord, String> RECIPENOTE = createField(DSL.name("recipenote"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_sales.content</code>.
     */
    public final TableField<VSalesRecord, String[]> CONTENT = createField(DSL.name("content"), SQLDataType.CLOB.array(), this, "");

    private VSales(Name alias, Table<VSalesRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VSales(Name alias, Table<VSalesRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_sales" AS  SELECT s.pk,
          s.trader,
          c.pk AS fk_camp,
          c.name,
          l.pk AS fk_location,
          l.name AS location,
          s.incredients,
          date_part('isoyear'::text, c.arrive) AS year,
          s.pk AS fk_sales,
          s.provider,
          s.cash,
          s.buydate,
          s.recipenumber,
          s.recipeshot,
          s.recipenote,
          array_agg(t.fk_salescontenttype) AS content
         FROM (((t_sales s
           LEFT JOIN t_camp c ON ((c.pk = s.fk_camp)))
           LEFT JOIN t_location l ON ((l.pk = c.fk_location)))
           LEFT JOIN t_salescontent t ON ((t.fk_sales = s.pk)))
        GROUP BY s.pk, s.trader, c.pk, c.name, l.pk, l.name, s.incredients, (date_part('isoyear'::text, c.arrive)), s.provider, s.cash, s.buydate, s.recipenumber, s.recipeshot;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_sales</code> table reference
     */
    public VSales(String alias) {
        this(DSL.name(alias), V_SALES);
    }

    /**
     * Create an aliased <code>public.v_sales</code> table reference
     */
    public VSales(Name alias) {
        this(alias, V_SALES);
    }

    /**
     * Create a <code>public.v_sales</code> table reference
     */
    public VSales() {
        this(DSL.name("v_sales"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VSales as(String alias) {
        return new VSales(DSL.name(alias), this);
    }

    @Override
    public VSales as(Name alias) {
        return new VSales(alias, this);
    }

    @Override
    public VSales as(Table<?> alias) {
        return new VSales(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VSales rename(String name) {
        return new VSales(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VSales rename(Name name) {
        return new VSales(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VSales rename(Table<?> name) {
        return new VSales(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales where(Condition condition) {
        return new VSales(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSales where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSales where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSales where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSales where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSales whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
