create table public.t_person (
  pk integer not null primary key generated always as identity,
  forename text,
  surname text,
  street text,
  zip text,
  city text,
  phone text,
  birthdate date,
  camprole public.enum_camprole,
  email text,
  fk_camp integer references public.t_camp(pk),
  fk_profile integer references public.t_profile(pk),
  accept boolean,
  progress public.enum_progress default 'requested',
  created timestamp without time zone default now(),
  sex public.enum_sex,
  fk_registrator integer references public.t_profile(pk),
  paid numeric(7,2),
  comment text,
  consent_catalog_photo boolean default false not null,
  required_price numeric(7,2),
  unique (forename, surname, birthdate, fk_camp)
);
