create view public.v_camp_budget as
 with x(money, camp) as (
     select coalesce(t_person.paid, 0.0) as cash,
      t_person.fk_camp
       from public.t_person
    union all
     select (t_sales.cash * ('-1'::integer)::numeric),
      t_sales.fk_camp
       from public.t_sales
    )
 select sum(x.money) as budget,
  c.pk as fk_camp,
  c.name as camp_name,
  date_part('year'::text, c.arrive) as year
   from (x
   left join public.t_camp c on ((c.pk = x.camp)))
  group by c.pk, c.name, c.arrive
  order by c.arrive;
